
export const exec = f => f()
export const pipe = (...fns) => (x) => fns.reduce((v, f) => f(v), x)
export const map = f => xs => xs.map(f)
export const mapObj = f => pipe(Object.entries, map(f), Object.fromEntries)

export const partition = (predicate, xs) => {
    const passed = []
    const failed = []

    const len = xs.length
    for (let i = 0; i < len; i++) {
        const value = xs[i]
        if (predicate(value)) {
            passed.push(value)
        } else {
            failed.push(value)
        }
    }

    return [passed, failed]
}
